*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* SISTEMA......:
* PROGRAMA.....: FUNCION.PRG
* AUTOR........: EDUARDO V. FLORES RIVAS
* FECHA........: 19-04-94
* ACTUALIZADO..: 23-05-95
* COMENTARIOS..: LIBRERIA DE FUNCIONES GENERALES.
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : LENNOSPC
* COMENTARIO: Devolver la longitud de una cadena sin espacios
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC LENNOSPC(Objeto)

LOCAL Longitud:=0

DO CASE
   CASE VALTYPE(Objeto)='C'
      Longitud:=LEN(ALLTRIM(Objeto))
   CASE VALTYPE(Objeto)='N'
      IF Objeto>0
         Longitud:=LENNUM(Objeto)
      ENDIF
ENDCASE

RETURN(Longitud)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : FECHAR
* COMENTARIO: TRANSFORMAR UNA FECHA (dd/mm/aa) a formato completo
*             EJEM: Fechar('19940505') = Jueves 5 de Mayo de 1994 (05/05/94)
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC FECHAR(Fecha)

LOCAL MesNom:={ 'Enero','Febrero','Marzo','Abril','Mayo','Junio','Julio',;
                'Agosto','Setiembre','Octubre','Noviembre','Diciembre'}
LOCAL DiaNom:={'Domingo','Lunes','Martes','Miercoles','Jueves','Viernes','Sbado'}
LOCAL UniYea
LOCAL LINE_FECHA

IF VALTYPE(Fecha)<>'D'
   IF VALTYPE(Fecha)='C'
      IF '/' $ Fecha
         Fecha:=CTOD(Fecha)
      ELSE
         Fecha:=STOD(Fecha)
      ENDIF
   ELSE
      RETURN(REPL(15,'?'))
   ENDIF
ENDIF
UniYea:=IF(YEAR(Fecha)>1999,' del ',' de ')
LINE_FECHA:=DiaNom[DOW(Fecha)]+' '+ALLTRIM(STR(DAY(Fecha)))+' de '+MesNom[MONTH(Fecha)]+UniYea+STR(YEAR(Fecha),4)

RETURN(LINE_FECHA)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : CMES
* COMENTARIO: RETORNA EL MES DE LA FECHA EN ESPAOL
*             EJEM: Noviembre
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC CMES(Fecha,Grande)

LOCAL MesNom:={ 'Enero','Febrero','Marzo','Abril','Mayo','Junio','Julio',;
                'Agosto','Setiembre','Octubre','Noviembre','Diciembre'}
LOCAL MesLine

DO CASE
   CASE VALTYPE(Fecha)='N'
      MesLin:=MesNom[Fecha]
   CASE VALTYPE(Fecha)='D'
      MesLin:=MesNom[MONTH(Fecha)]
   CASE VALTYPE(Fecha)='C'
      Fecha:=CTOD(Fecha)
      MesLin:=MesNom[MONTH(Fecha)]
ENDCASE
MesLin:=IF(Grande<>NIL,UPPER(MesLin),MesLin)

RETURN(MesLin)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : CDIA
* COMENTARIO: RETORNA EL DIA DE LA FECHA EN ESPAOL
*             EJEM: Domingo
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC CDIA(Fecha)

LOCAL DiaNom:={'Domingo','Lunes','Martes','Miercoles','Jueves','Viernes','Sbado'}
LOCAL DiaLin

IF VALTYPE(Fecha)='C'
   Fecha:=CTOD(Fecha)
ENDIF
DiaLin:=DiaNom[DOW(Fecha)]

RETURN(DiaLin)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : STOD
* COMENTARIO: Convertir fecha formato STRING a formato DATE
*             Esta funcin es la contraria a DTOS(fecha).
*             Ejem:
*             STOD('19943101') --> 31/01/1994 (Formato DATE)
*             Nota: String debe ser una cadena de fecha vlida.
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC STOD(String)

LOCAL AS:=SUBSTR(String,3,2)
LOCAL MS:=SUBSTR(String,5,2)
LOCAL DS:=RIGHT(String,2)
LOCAL DChar:=DS+'/'+MS+'/'+AS
DChar:=CTOD(DChar)

RETURN(DChar)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : STOC
* COMENTARIO: Convertir fecha en formato STRING a formato fecha CHARACTER
*            Esta funcin es la contraria a DTOS(fecha)
*            Ejem: STOC('19943101') convierte a '31/01/1994'
*                                 (Formato CHARACTER)
*               STOC('19943101',2) convierte a '31/01/94'
*                                 (Formato CHARACTER)
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC STOC(String,KAnual)

LOCAL AS , MS , DS , DChar

AS:=IF(KAnual=NIL,LEFT(String,4),SUBSTR(String,3,2))
MS:=SUBSTR(String,5,2)
DS:=RIGHT(String,2)
DChar:=DS+'/'+MS+'/'+AS

RETURN(DChar)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : CTOS
* COMENTARIO: Convertir fecha de formato CHARACTER a formato STRING.
*             Esta funcin es la contraria a STOC(fecha)
*             Ejem: CTOS('31/12/94') convierte a '19941231'
*
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC CTOS(String)

LOCAL Dchar := DTOS(CTOD(String))

RETURN(DChar)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : DTOC4
* COMENTARIO: Convertir fecha de formato DATE a formato CHARACTER con
*             4 digitos para el ao.
*
*             Ejem: DTOC4(DATE()) convierte a '31/12/2005'
*
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC DTOC4(dFecha)

LOCAL sFecha:=DTOS(dFecha)
LOCAL cFecha:=RIGHT(sFecha,2)+'/'+SUBSTR(sFecha,5,2)+'/'+LEFT(sFecha,4)

RETURN(cFecha)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : FTOV
* COMENTARIO: Convertir fecha de formato CHARACTER  DATE a un VALOR.
*             Ejem: fechav=FTOV('31/12/94')
*                   fechav=19941231
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC FTOV(FechaX)

LOCAL FechaV

DO CASE
   CASE VALTYPE(FechaX)='C'
      IF AT('/',FechaX) > 0
         FechaV := VAL(CTOS(FechaX))
      ELSE
         FechaV := VAL(FechaX)
      ENDIF
   CASE VALTYPE(FechaX)='D'
      FechaV:=VAL(DTOS(FechaX))
   OTHERWISE
      FechaV:=0
ENDCASE

RETURN(FechaV)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : CTOC
* COMENTARIO: Verifica si una fecha ingresada mediante un GET del tipo
*             GET fecha PICT '@D' o una fecha CHARACTER = '31/12/96'
*             es vlida.
*             Si no es vlida y el parametro <ajuste> es 1 bscara la fecha
*             posterior ms prxima.  Si <ajuste> es 0 buscar la fecha
*             anterior ms prxima.
* RESULTADO : La funcin devuelve una fecha vlida en formato CHARACTER
*             Ejem:  CTOC('32/12/96',0) => '31/12/96'
*                    CTOC('32/12/96',1) => '01/01/97'
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC CTOC(Fecha,Ajuste,IniFin)

LOCAL DFec
LOCAL MFec
LOCAL AFec

Ajuste:=IF(Ajuste=NIL,0,Ajuste)
IF DTOS(CTOD(Fecha))=SPACE(8)
   DFec:=VAL(LEFT(Fecha,2))
   MFec:=VAL(SUBSTR(Fecha,4,2))
   AFec:=VAL(RIGHT(Fecha,2))
   MFec:=IF(MFec>12,12,MFec)
   MFec:=IF(MFec<1,1,MFec)
   DFec:=IF(DFec>31,31,DFec)
   DFec:=IF(DFec<1,1,DFec)
   Fecha:=STRZERO(DFec,2)+'/'+STRZERO(MFec,2)+'/'+STRZERO(AFec,2)
   DO CASE
      CASE Ajuste=0
         DO WHILE DTOS(CTOD(Fecha))=SPACE(8)
            DFec--
            Fecha:=STRZERO(DFec,2)+'/'+STRZERO(MFec,2)+'/'+STRZERO(AFec,2)
         ENDDO
      CASE Ajuste=1
         DO WHILE DTOS(CTOD(Fecha))=SPACE(8)
            DFec:=1
            MFec++
            Fecha:=STRZERO(DFec,2)+'/'+STRZERO(MFec,2)+'/'+STRZERO(AFec,2)
         ENDDO
    ENDCASE
ENDIF

RETURN(Fecha)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : F2ANUALMES
* COMENTARIO: Devuelve una cadena 6 digitos
*             los 4 primeros digitos son el ao
*             y los 2 restantes son el mes
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC F2ANUALMES(xFecha)

LOCAL sFecha

DO CASE
   CASE VALTYPE(xFecha)='C'
      sFecha:=LEFT(CTOS(xFecha),6)
   CASE VALTYPE(xFecha)='D'
      sFecha:=LEFT(DTOS(xFecha),6)
   OTHERWISE
      sFecha:=''
ENDCASE

RETURN(sFecha)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : F2ANUAL
* COMENTARIO: Devuelve el ao de la fecha en formato CHARACTER.
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC F2ANUAL(xFecha)

LOCAL sFecha

DO CASE
   CASE VALTYPE(xFecha)='C'
      sFecha:=LEFT(CTOS(xFecha),4)
   CASE VALTYPE(xFecha)='D'
      sFecha:=LEFT(DTOS(xFecha),4)
   OTHERWISE
      sFecha:=''
ENDCASE

RETURN(sFecha)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : VALSTR
* COMENTARIO: Convertir un nmero a una cadena sin espacios
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC VALSTR(Number)

LOCAL STRNUM:=ALLTRIM(STR(Number))

RETURN(STRNUM)


* ------------------------------------------------------------------------
* ------------------------------------------------------------------------
* FUNCION   : VALSTRPAD
* COMENTARIO: Convertir un nmero a una cadena con espacios de relleno
*             a la derecha.
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC VALSTRPAD(Valor,Espacio)

LOCAL SubValor1:=ALLTRIM(STR(Valor))
LOCAL SubValor2

IF LEN(SubValor1)<=Espacio
   SubValor2:=PADL(SubValor1,Espacio)
ELSE
   SubValor2:=LEFT(SubValor1,Espacio)
ENDIF

RETURN(SubValor2)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : STRVAL
* COMENTARIO: Convertir una cadena a un nmero
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC STRVAL(Cadena)
LOCAL CNum:=''
LOCAL c , dig

FOR c=1 TO LEN(Cadena)
   dig=SUBSTR(Cadena,c,1)
   IF dig $ '-0123456789.'
      CNum+=dig
   ENDIF
NEXT

RETURN(VAL(CNum))


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : NUMPURO
* COMENTARIO: Saca de una cadena todo lo que no sea nmeros.
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC STRNUMPURO(Cadena)
LOCAL CNum:=''
LOCAL c
LOCAL dig

FOR c=1 TO LEN(Cadena)
   dig=SUBSTR(Cadena,c,1)
   IF dig $ '0123456789'
      CNum+=dig
   ENDIF
NEXT

RETURN(CNum)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : STRR
* COMENTARIO: Convertir un nmero a una cadena y rellenar c/espacios
*             a la derecha.
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC STRR(Number,Spaces)

LOCAL STRNUM:=PADR(ALLTRIM(STR(Number)),Spaces)

RETURN(STRNUM)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : STRCOMA
* COMENTARIO: Convertir un nmero a una cadena con comas.
*             Ejem.: 1123456.78 se convierte a '1'123,456.78'
* SINTAXIS  : Numero=STRCOMA(<VarNum>)
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC STRCOMA(Nmr,LnE,LnD)

LOCAL SNum , Ent , Dec , Coma , LnI , Num , tri

Nmr:=IF(VALTYPE(Nmr)<>'N',VAL(Nmr),Nmr)
LnE:=IF(LnE=NIL,12,LnE)
LnD:=IF(LnD=NIL,2,LnD)
SNum:=ALLTRIM(STR(Nmr,LnE,LnD))
Ent:=IF(LnD>0,LEFT(SNum,LEN(SNum)-(LnD+1)),SNum)
Dec:=IF(LnD>0,RIGHT(SNum,LnD+1),'')
Coma:=','
LnI:=LEN(Ent)-3
Tpe:=IF(Nmr<0,2,1)

FOR tri=LnI TO Tpe STEP -3
   Ent:=LEFT(Ent,tri)+Coma+RIGHT(Ent,LEN(Ent)-tri)
   Coma:=CHR(39)
NEXT
Num:=PADL(Ent,LnE-(LnD+1))+Dec

RETURN(Num)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : STR2DOC
* COMENTARIO: Convertir una cadena a nmero de DOCUMENTO para busqueda.
*             Ejem.: '3-6850' se convierte a '003-00006850'
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC STR2DOC(cString)

LOCAL cDocNum := ' '
LOCAL nGuion  := 0
LOCAL nLargo  := 0

   cString := ALLTRIM(cString)
   nGuion := AT('-',cString)
   nLargo := LEN(cString)
   IF nGuion > 0 .AND. nLargo > 3
      cIzq := LEFT( cString , nGuion-1 )
      cDer := RIGHT( cString , nLargo-nGuion )
      cDocNum := STRZERO(VAL(cIzq),3)+'-'+STRZERO(VAL(cDer),8)
   ENDIF

RETURN(cDocNum)


*>----------------------------------------------------------------------<*
*>----------------------------------------------------------------------<*
* FUNCION   : ASUM
* COMENTARIO: Devuelve la suma de un array unidimensional.
* SINTAXIS  : ASUM(aArray)
*>----------------------------------------------------------------------<*
*>----------------------------------------------------------------------<*

FUNC ASUM(aArray)

LOCAL TotalSuma:=0

AEVAL(aArray,{|nElem| TotalSuma+=nElem})

RETURN(TotalSuma)


*>----------------------------------------------------------------------<*
*>----------------------------------------------------------------------<*
* FUNCION   : SUMAPORC
* COMENTARIO: Le suma a la cifra el porcentaje pasado.
*>----------------------------------------------------------------------<*
*>----------------------------------------------------------------------<*

FUNC SUMAPORC(Cifra,Porcentaje)

LOCAL Resulta := Cifra * (1+(Porcentaje/100))

RETURN(Resulta)


*>----------------------------------------------------------------------<*
*>----------------------------------------------------------------------<*
* FUNCION   : RESTPORC
* COMENTARIO: Le resta a la cifra el porcentaje pasado.
*>----------------------------------------------------------------------<*
*>----------------------------------------------------------------------<*

FUNC RESTAPORC(Cifra,Porcentaje)

LOCAL Resulta:=Cifra*(1-(Porcentaje/100))

RETURN(Resulta)


*>----------------------------------------------------------------------<*
*>----------------------------------------------------------------------<*
* FUNCION   : SUMIGV
* COMENTARIO: Agrega el IGV a la cifra pasada como parametro
*             NOTA: DEBE EXISTIR LA VARIABLE PUBLICA SIS_IGV.
* SINTAXIS  : Suma=SUMIGV(20.45,.T.) --> "
*>----------------------------------------------------------------------<*
*>----------------------------------------------------------------------<*

FUNC SUMAIGV(nCifra,lIgv)

LOCAL nResulta

IF lIgv
   nResulta := ROUND(nCifra*(1+(SIS_IGV/100)),2)
ELSE
   nResulta := nCifra
ENDIF

RETURN(nResulta)


*>----------------------------------------------------------------------<*
*>----------------------------------------------------------------------<*
* FUNCION   : RESTAIGV
* COMENTARIO: Resta el IGV a la cifra pasada como parametro
*             NOTA: DEBE EXISTIR LA VARIABLE PUBLICA SIS_IGV.
* SINTAXIS  : Nuevo=RESTAIGV(20.45,.T.) --> "
*>----------------------------------------------------------------------<*
*>----------------------------------------------------------------------<*

FUNC RESTAIGV(nCifra,lIgv)

LOCAL nResulta

IF lIgv
   nResulta := ROUND(nCifra/(1+(SIS_IGV/100)),2)
ELSE
   nResulta := nCifra
ENDIF

RETURN(nResulta)


*>----------------------------------------------------------------------<*
*>----------------------------------------------------------------------<*
* FUNCION   : VVF2PVF
* COMENTARIO:
* SINTAXIS  :
*>----------------------------------------------------------------------<*
*>----------------------------------------------------------------------<*

FUNC VVF2PVF(nVVF,lIGV)

LOCAL nPVF := 0

   IF lIGV = NIL
      lIGV := .T.
   ENDIF

   IF lIGV = .T.
      nPVF := SUMAIGV(nVVF,lIGV)
   ELSE
      nPVF := nVVF
   ENDIF

RETURN(nPVF)


*>----------------------------------------------------------------------<*
*>----------------------------------------------------------------------<*
* FUNCION   : PVF2VVF
* COMENTARIO:
* SINTAXIS  :
*>----------------------------------------------------------------------<*
*>----------------------------------------------------------------------<*

FUNC PVF2VVF(nPVF,lIGV)

LOCAL nVVF

   IF lIGV = NIL
      lIGV := .T.
   ENDIF

   IF lIGV = .T.
      nVVF := RESTAIGV(nPVF,lIGV)
   ELSE
      nVVF := nPVF
   ENDIF

RETURN(nVVF)


*>----------------------------------------------------------------------<*
*>----------------------------------------------------------------------<*
* FUNCION   : NETO2PREC
* COMENTARIO:
* SINTAXIS  :
*>----------------------------------------------------------------------<*
*>----------------------------------------------------------------------<*

FUNC NETO2PREC(XNeto,XUtil,XDcto)

LOCAL Xvvf,XPrecio

Xvvf:=XNeto*(1+(SIS_IGV/100))
XPrecio:=(Xvvf*(1+(XUtil/100)))*(1-(XDcto/100))

RETURN(XPrecio)


*>----------------------------------------------------------------------<*
*>----------------------------------------------------------------------<*
* FUNCION   : NETO2REAL
* COMENTARIO:
* SINTAXIS  :
*>----------------------------------------------------------------------<*
*>----------------------------------------------------------------------<*

FUNC NETO2REAL(XNeto,XDcto1,XDcto2,XDcto3)

LOCAL nNetoIgv
LOCAL nNetoDct1
LOCAL nNetoDct2
LOCAL nNetoDct3
LOCAL nReal

nNetoIgv := XNeto     * (1+(SIS_IGV/100))
nNetoDct1:= nNetoIgv  * (1-(XDcto1/100))
nNetoDct2:= nNetoDct1 * (1-(XDcto2/100))
nNetoDct3:= nNetoDct2 * (1-(XDcto3/100))
nReal:=nNetoDct3

RETURN(nReal)


*>----------------------------------------------------------------------<*
*>----------------------------------------------------------------------<*
* FUNCION   : NETO2VALOR
* COMENTARIO: Transforma el costo neto al valor total.
*             Usado para el mdulo de NOTAS.PRG
* SINTAXIS  :
*>----------------------------------------------------------------------<*
*>----------------------------------------------------------------------<*

FUNC NETO2VALOR(nNeto,nUnid,nFrac,nDctoD,nDctoI,nArtiFrac)

LOCAL nValor

nU_Vvf  := nNeto   * ( 1 + (SIS_IGV/100) )
nU_Dct1 := nU_Vvf  * ( 1 - (nDctoD/100) )
nU_Dct2 := nU_Dct1 * ( 1 - (nDctoI/100) )

DO CASE
   CASE nUnid>0
      nValor := nU_Dct2 * nUnid
   CASE nFrac>0
      nValor := nU_Dct2 * nFrac
ENDCASE

RETURN(nValor)


*>----------------------------------------------------------------------<*
*>----------------------------------------------------------------------<*
* FUNCION   : VALOR2NETO
* COMENTARIO: Transforma el valor total al costo neto.
*             Usado para el mdulo de NOTAS.PRG
* SINTAXIS  :
*>----------------------------------------------------------------------<*
*>----------------------------------------------------------------------<*

FUNC VALOR2NETO(nValor,nUnid,nFrac,nDctoD,nDctoI,nArtiFrac)

LOCAL nNeto

nU_Vvf  := nValor  / ( 1 - (nDctoI/100) )
nU_Dct1 := nU_Vvf  / ( 1 - (nDctoD/100) )
nU_Dct2 := nU_Dct1 / ( 1 + (SIS_IGV/100) )

DO CASE
   CASE nUnid>0
      nNeto := nU_Dct2 / nUnid
   CASE nFrac>0
      nNeto := nU_Dct2 / nFrac
ENDCASE

RETURN(nNeto)


*>----------------------------------------------------------------------<*
*>----------------------------------------------------------------------<*
* FUNCION   : REAL2PREC
* COMENTARIO:
* SINTAXIS  :
*>----------------------------------------------------------------------<*
*>----------------------------------------------------------------------<*

FUNC REAL2PREC(XReal,XUtil)

LOCAL XPrecio

XPrecio:=XReal*(1+(XUtil/100))

RETURN(XPrecio)


*>----------------------------------------------------------------------<*
*>----------------------------------------------------------------------<*
* FUNCION   : PREC2NETO
* COMENTARIO: 
* SINTAXIS  :
*>----------------------------------------------------------------------<*
*>----------------------------------------------------------------------<*

FUNC PREC2NETO(nPrecio)

LOCAL nNeto:=nPrecio/(1+(SIS_IGV/100))

RETURN(nNeto)


*>----------------------------------------------------------------------<*
*>----------------------------------------------------------------------<*
* FUNCION   : PREC2IGV
* COMENTARIO: Devuelve el subtotal IGV de nPrecio
* SINTAXIS  :
*>----------------------------------------------------------------------<*
*>----------------------------------------------------------------------<*

FUNC PREC2IGV(nPrecio)

LOCAL nNeto:=Prec2Neto(nPrecio)
LOCAL nIgv:=nPrecio-nNeto

RETURN(nIgv)


*>----------------------------------------------------------------------<*
*>----------------------------------------------------------------------<*
* FUNCION   : SUGERIDO
* COMENTARIO: Calcula el precio sugerido para el preciado por NETO.
* SINTAXIS  :
*>----------------------------------------------------------------------<*
*>----------------------------------------------------------------------<*

FUNC SUGERIDO(xneto,xutil)

LOCAL PrecioSug

PrecioSug:=xneto+(xneto*(SIS_IGV/100))
PrecioSug:=PrecioSug+(PrecioSug*(xutil/100))

RETURN(PrecioSug)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : OBTENIDO
* COMENTARIO: Devuelve el porcentaje de descuento que se obtuvo
*             al comprar el producto.
* SINTAXIS  : Descuento=OBTENIDO(Costo_Neto,Costo_Real)
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC OBTENIDO(Neto,Real)

LOCAL Descto  := Neto-Real
LOCAL Pond    := ROUND((Descto*100)/Neto,2)

IF Pond<0 .OR. Real=0
   Pond:=0
ENDIF

RETURN(Pond)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : UTILIDAD
* COMENTARIO: Devuelve el porcentaje de utilidad obtenida (PRECIO - COSTO)
* SINTAXIS  : Descuento=OBTENIDO(Costo_Neto,Costo_Real)
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC UTILIDAD(CostoReal,PrecioVent)

LOCAL Ganancia
LOCAL Porcenta := 0

IF CostoReal > 0 .AND. PrecioVent > 0
   IF PrecioVent>CostoReal
      Ganancia:=PrecioVent-CostoReal
   ELSE
      Ganancia:=CostoReal-PrecioVent
   ENDIF
   Porcenta:=ROUND((Ganancia*100)/CostoReal,2)
ENDIF

RETURN(Porcenta)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : DESCONTADO
* COMENTARIO: Devuelve el porcentaje de descuento que se da al cliente
* SINTAXIS  : Descuento=DESCONTADO(Costo_Neto,Utilidad,Precio_Pub)
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC DESCONTADO(nNeto,nUtil,nPrecio)

LOCAL nSugeri:=SUGERIDO(nNeto,nUtil)
LOCAL nDescto:=nSugeri-nPrecio
LOCAL nPorcen:=(nDescto*100)/nPrecio

RETURN(nPorcen)


*>----------------------------------------------------------------------<*
*>----------------------------------------------------------------------<*
*>----------------------------------------------------------------------<*

FUNC SumaNumDoc(cnumdoc,ncuanto)

LOCAL snumdoc,vnumdoc,lnumdoc,vnewdoc,snewdoc,cnewdoc

cnumdoc := ALLTRIM(cnumdoc)
ncuanto := IF( ncuanto = NIL , 1 , ncuanto )

IF AT('-',cnumdoc)>0
   lnumdoc:=LEN(cnumdoc)
   snumdoc:=STRNUMPURO(cnumdoc)
   vnumdoc:=VAL(snumdoc)
   vnewdoc:=vnumdoc+ncuanto
   snewdoc:=STRZERO(vnewdoc,lnumdoc-1)
   cnewdoc:=LEFT(snewdoc,3)+'-'+RIGHT(snewdoc,lnumdoc-4)
ELSE
   cnewdoc:=STRZERO(VAL(cnumdoc)+ncuanto,LEN(cnumdoc))
ENDIF

RETURN(cnewdoc)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : REDO1
* COMENTARIO: REDONDEAR NUMEROS REALES A UN NUMERO CON
*             2 CIFRAS DECIMALES. 1er METODO.
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC REDO1(Numero)

LOCAL NumerC:=LTRIM(STR(Numero,8,2))
LOCAL Entero:=VAL(LEFT(NumerC,AT('.',NumerC)))
LOCAL DecimC:=SUBSTR(NumerC,AT('.',NumerC),3)
LOCAL DecimN:=VAL(DecimC)
LOCAL DecimR:=VAL(RIGHT(DecimC,1))
LOCAL DecimL:=VAL(LEFT(DecimC,2))  //digito izq. del decimal con el punto
LOCAL NewNum

IF DecimN>0
   DO CASE
      CASE Numero<.10
         DecimN:=.10
      CASE DecimR>0
         DO CASE
            CASE DecimR>=7  //lleva .17,.18,.19 a .20
               DecimN:=DecimL+.10
            CASE DecimR>=4  //lleva .14,.15,.16 a .15
               DecimN:=DecimL+.05
            OTHERWISE
               DecimN:=DecimL
         ENDCASE
   ENDCASE
ENDIF
NewNum:=Entero+DecimN

RETURN(ROUND(NewNum,2))


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : REDO2
* COMENTARIO: REDONDEAR NUMEROS REALES A UN NUMERO CON 2 CIFRAS DEC.
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC REDO2(Numero)

LOCAL NumerC:=LTRIM(STR(Numero,8,2))
LOCAL Entero:=VAL(LEFT(NumerC,AT('.',NumerC)))
LOCAL DecimC:=SUBSTR(NumerC,AT('.',NumerC),3)
LOCAL DecimN:=VAL(DecimC)
LOCAL DecimR:=VAL(RIGHT(DecimC,1))
LOCAL DecimL:=VAL(LEFT(DecimC,2))  //digito izq. del decimal con el punto
LOCAL NewNum

IF DecimN>0
   DO CASE
      CASE Numero<.10
         DecimN:=.10
      CASE DecimR>0
         IF DecimR>=5
            DecimN:=DecimL+.10
         ELSE
            DecimN:=DecimL
         ENDIF
   ENDCASE
ENDIF
NewNum:=Entero+DecimN

RETURN(ROUND(NewNum,2))


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : REDO3
* COMENTARIO: REDONDEAR NUMEROS REALES A UN NUMERO CON 2 CIFRAS DEC.
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC REDO3(Numero)

LOCAL NumerC:=LTRIM(STR(Numero,8,2))
LOCAL Entero:=VAL(LEFT(NumerC,AT('.',NumerC)))
LOCAL DecimC:=SUBSTR(NumerC,AT('.',NumerC),3)
LOCAL DecimN:=VAL(DecimC)
LOCAL DecimR:=VAL(RIGHT(DecimC,1))
LOCAL DecimL:=VAL(LEFT(DecimC,2))  //digito izq. del decimal con el punto
LOCAL NewNum

IF DecimN>0
   DO CASE
      CASE Numero<.10
         DecimN:=.10
      CASE DecimR>6
         DecimN:=DecimL+.10
      CASE DecimR>0
         DecimN:=DecimL+.05
   ENDCASE
ENDIF
NewNum:=Entero+DecimN

RETURN(ROUND(NewNum,2))


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : REDO4
* COMENTARIO: REDONDEAR NUMEROS REALES A UN NUMERO CON 2 CIFRAS DEC.
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC REDO4(Numero)

LOCAL NumerC:=LTRIM(STR(Numero,8,2))
LOCAL Entero:=VAL(LEFT(NumerC,AT('.',NumerC)))
LOCAL DecimC:=SUBSTR(NumerC,AT('.',NumerC),3)
LOCAL DecimN:=VAL(DecimC)
LOCAL DecimR:=VAL(RIGHT(DecimC,1))
LOCAL DecimL:=VAL(LEFT(DecimC,2))  //digito izq. del decimal con el punto
LOCAL NewNum

IF DecimN>0
   DO CASE
      CASE Numero<.10
         DecimN:=.10
      CASE DecimR>0
         DecimN:=DecimL+.10
   ENDCASE
ENDIF
NewNum:=Entero+DecimN

RETURN(ROUND(NewNum,2))


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : ESPAR
* COMENTARIO: DEVUELVE UN LOGICO SI LA Cifra es PAR
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC ESPAR(Cifra)

LOCAL SiEsPar:=.F.

IF Cifra=INT(Cifra/2)
   SiEsPar:=.T.
ENDIF

RETURN(SiEsPar)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : INTPLUS
* COMENTARIO: REDONDEA UN DECIMAL A UN NUMERO ENTERO SUPERIOR.
*             Si nValor es entero lo devuelve sin cambios.
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC INTPLUS(nDecimal)

LOCAL nEntero

IF nDecimal=INT(nDecimal)
   nEntero=nDecimal
ELSE
   nEntero=INT(nDecimal)+1
ENDIF

RETURN(nEntero)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : CMTOFC
* COMENTARIO: CALCULA LA ALTURA Y ANCHO DEL PAPEL EN FILAS Y COLUMNAS.
*             Altura y Ancho deben ser en centimetros.
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC CMTOFC(Altura,Ancho)

LOCAL Size:=ARRAY(4)

Size[1]:=INT(Altura/0.425)   && Filas disponibles en normal.
Size[2]:=INT(Altura/0.425)   && Filas disponibles en menuda.
Size[3]:=INT(Ancho/0.26)     && Columnas disponibles en normal.
Size[4]:=INT(Ancho/0.15)     && Columnas disponibles en menuda.

RETURN(Size)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : CMTOIN
* COMENTARIO: TRANSFORMA MEDIDA EN CM A PULGADAS.
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC CMTOIN(Cm)

LOCAL In:=Cm/2.495

RETURN(In)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : GETSIZE
* COMENTARIO: DEVUELVE LA LONGITUD DEL ELEMENTO MAS LARGO DE UNA ARRAY.
*             Lo uso en VISUALES.PRG
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC GETSIZE(aOpcion)

LOCAL talla:=0

ASCAN(aOpcion,{|str| talla:=MAX(talla,LEN(str))})

RETURN(talla)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : DELALL
* COMENTARIO: FUNCION PARA BORRAR ARCHIVOS USANDO LOS CARACTERES COMODIN.
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

PROC DELALL(Ruta,Archi)

LOCAL Ttl:=ADIR(Ruta+Archi)
LOCAL FtD

IF Ttl>0
   FtD:=ARRAY(Ttl)
   ADIR(Ruta+Archi,FtD)
   FOR d=1 TO Ttl
      FERASE(Ruta+FtD[d])
   NEXT
ENDIF

RETURN


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : ISDIR
* COMENTARIO: VERIFICAR EXISTENCIA DE UN DIRECTORIO.
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC ISDIR(Directorio)

LOCAL aLista
LOCAL nDir
LOCAL nRuta
LOCAL nPos
LOCAL Existe := .F.
LOCAL Ruta
LOCAL Carpeta

IF AT('\',Directorio) > 0
   FOR nRuta=LEN(Directorio) TO 1 STEP -1
      IF SUBSTR(Directorio,nRuta,1) = '\'
         Ruta    := LEFT(Directorio,nRuta)
         Carpeta := RIGHT(Directorio,nRuta+1)
      ENDIF
   NEXT
ELSE
   Ruta := Directorio
ENDIF

aLista := DIRECTORY( Ruta+'*' , 'D' )

FOR nDir = 1 TO LEN(aLista)
   IF aLista[nDir,1] = Carpeta
      Existe := .T.
   ENDIF
NEXT

RETURN( Existe )


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : NOHAYNADA
* COMENTARIO: Revisa la base de datos actual para ver si esta vacia.
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC NOHAYNADA

LOCAL Count:=0
LOCAL NoHay:=.T.
LOCAL OldRecno

IF LASTREC()>0
   OldRecno:=RECNO()
   DBGOTOP()
   DO WHILE .NOT. EOF()
      IF .NOT. DELETED()
         Count++
      ENDIF
      SKIP
   ENDDO
   NoHay:=IF(Count=0,.T.,.F.)
   IF NoHay=.F.
      DBGOTO(OldRecno)
   ENDIF
ENDIF

RETURN(NoHay)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : DBSAVEORD
* COMENTARIO: Esta funcin es para usar antes de los REPLACE en bases
*             de datos indexadas.
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC DBSAVEORD

LOCAL OrdActual:=INDEXORD()

DBSETORDER(0)

RETURN(OrdActual)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : SELLOFECHA
* COMENTARIO:
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC SELLOFECHA

LOCAL cSello := CTOS(DTOC(DATE()))+STRTRAN(TIME(),':')

RETURN(cSello)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC Cell2VAL( xCadena )

LOCAL nNumero := 0
LOCAL cTipo   := VALTYPE(xCadena)

   DO CASE
      CASE cTipo = 'C'
         nNumero := VAL( xCadena )
      CASE cTipo = 'N'
         nNumero := xCadena
      CASE cTipo = 'U'
         nNumero := 0
      OTHERWISE
         MsgInfo('Error : '+cTipo)
   ENDCASE

RETURN( nNumero )


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC Cell2CHR( xCadena )

LOCAL cCadena := ' '

   IF ! VALTYPE( xCadena ) = 'U'
      DO CASE
         CASE VALTYPE(xCadena) = 'C'
            cCadena := xCadena
         CASE VALTYPE(xCadena) = 'N'
            cCadena := VALSTR(xCadena)
         CASE VALTYPE(xCadena) = 'D'
            cCadena := DTOC(xCadena)
      ENDCASE
   ENDIF

RETURN( cCadena )